;; -*- mode: scheme; coding: utf-8 -*-

;;;; Copyright (C) 2011, 2012
;;;; Free Software Foundation, Inc.

;;;; This library is free software: you can redistribute it and/or
;;;; modify it under the terms of the GNU General Public License as
;;;; published by the Free Software Foundation, either version 3 of
;;;; the License, or (at your option) any later version.

;;;; This library is distributed in the hope that it will be useful, but
;;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;;; General Public License for more details.

;;;; You should have received a copy of the GNU General Public License
;;;; along with this library.  If not, see <http://www.gnu.org/licenses/>.
;;;;

;;; Commentary:

;;; Code:

(define-module (gtk mdialog-1b)
  ;; guile/guile-gnome
  :use-module (ice-9 format)
  :use-module (oop goops)
  :use-module (gnome gtk)
  :use-module (gnome glade)
  :use-module (gnome gobject)

  ;; common
  :use-module (macros reexport)
  :use-module (gtk gtk2)
  :use-module (system aglobs)

  :export (md1b/select-gui))


(eval-when (compile load eval)
  (re-export-public-interface (system aglobs))
  (let ((commongtkdir (dirname (search-path %load-path "gtk/mdialog-1b.scm"))))
    (aglobs/set 'mdgladefile (string-append commongtkdir "/glade/mdialogs.glade"))))


;;;
;;; Globals
;;;

(define *md1b-widget* #f)


;;;
;;; Dialog
;;;

(define-class <md1b-widget> ()
  (xml-code :accessor xml-code :init-keyword :xml-code :init-value #f)
  (dialog :accessor dialog :init-keyword :dialog :init-value #f)
  (image :accessor image :init-keyword :image :init-value #f)
  (label :accessor label :init-keyword :label :init-value #f)
  (ok-bt :accessor ok-bt :init-keyword :ok-bt :init-value #f)
  (ok-callback :accessor ok-callback :init-keyword :ok-callback :init-value #'identity))

(define (md1b/make-dialog)
  (let* ((xml (glade-xml-new (aglobs/get 'mdgladefile) #f "md1b"))
	 (md1b-dialog (get-widget xml "md1b"))
	 (img (get-widget xml "md1b/image"))
	 (lb (get-widget xml "md1b/label"))
	 (ok (get-widget xml "md1b/ok_bt"))
	 (md1b-widget (make <md1b-widget>
			:xml-code xml
			:dialog md1b-dialog
			:image img
			:label lb
			:ok-bt ok)))
    ;; (md1b/translate-dialog md1b-widget)
    (connect md1b-dialog
	     'delete-event
	     (lambda (widget event)
	       ;; (format #t "Delete event triggered~%")
	       ((ok-callback md1b-widget))
	       (set! *md1b-widget* #f)
	       #f))
    (connect ok
	     'clicked
	     (lambda (button)
	       ((ok-callback md1b-widget))
	       (set-modal md1b-dialog #f)
	       (hide md1b-dialog)))
    md1b-widget))


;;;
;;; API
;;;

(define (md1b/select-gui-1 md1b-widget parent title p-text s-text ok-callb)
  (let ((md1b-dialog (dialog md1b-widget)))
    (if parent
	(set-transient-for md1b-dialog parent))
    ;; (set-image md1b-dialog (gtk-image-new-from-stock 'dialog-warning))
    ;; (format #t "~S~%" (get-image md1b-dialog))
    (set-title md1b-dialog title)
    (set-markup (label md1b-widget) (gtk2/span-message p-text s-text))
    (set! (ok-callback md1b-widget) ok-callb)
    (set-modal md1b-dialog #t)
    (set-keep-above md1b-dialog #t)
    (show-all md1b-dialog)))

(define (md1b/select-gui parent title p-text s-text ok-callb)
  (let ((md1b-widget (or *md1b-widget*
			 (let ((md1b-widget (md1b/make-dialog)))
			   (set! *md1b-widget* md1b-widget)
			   md1b-widget))))
    (md1b/select-gui-1 md1b-widget parent title p-text s-text ok-callb)))


;;;
;;; Translation
;;;

(define (md1b/translate-dialog md1b-widget)
  (let ((xml (xml-code md1b-widget)))
    ;; (set-title (dialog md1b-widget) (_ "Warning"))
    #f))


#!

(use-modules (gtk mdialog-1b))
(reload-module (resolve-module '(gtk mdialog-1b)))

(use-modules (gnome gtk graphical-repl))
(guile-gtk-repl)

(md1b/select-gui #f
		 "My title"
		 "Incorrect code"
		 "Incorrect code: 'bibi' is an unkown variable"
		 (lambda () (display "Ok")))

!#
