;; -*- mode: scheme; coding: utf-8 -*-


;;;; Copyright (C) 2011, 2012
;;;; Free Software Foundation, Inc.

;;;; This library is free software: you can redistribute it and/or
;;;; modify it under the terms of the GNU General Public License as
;;;; published by the Free Software Foundation, either version 3 of
;;;; the License, or (at your option) any later version.

;;;; This library is distributed in the hope that it will be useful, but
;;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;;; General Public License for more details.

;;;; You should have received a copy of the GNU General Public License
;;;; along with this library.  If not, see <http://www.gnu.org/licenses/>.
;;;;

;;; Commentary:

;;; Code:

(define-module (macros when)
  :export (when 
	   unless))


(define-syntax when
  (syntax-rules ()
    ((when ?test . ?body)
     (if ?test (begin . ?body)))))

(define-syntax unless
  (syntax-rules ()
    ((unless ?test . ?body)
     (if (not ?test) (begin . ?body)))))


#!

(use-modules (macros when))
(reload-module (resolve-module '(macros when)))


(when #t
  (display "when 1\n")
  (display "when 2\n")
  (display "...\n"))

(unless #f
  (display "unless 1\n")
  (display "unless 2\n")
  (display "...\n"))

!#
