;; -*- mode: scheme; coding: utf-8 -*-

;;;; Copyright (C) 2011, 2012
;;;; Free Software Foundation, Inc.
;;;;
;;;; This library is free software; you can redistribute it and/or
;;;; modify it under the terms of the GNU General Public License as
;;;; published by the Free Software Foundation; either version 3 of
;;;; the License, or (at your option) any later version.
;;;; 
;;;; This library is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;;; General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with this library; if not, write to the Free Software
;;;; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
;;;; 02110-1301 USA
;;;;

;;; Commentary:

;;; Code:

(define-module (nbs hex)
  ;; guile
  :use-module (ice-9 format)
  :use-module (ice-9 receive)

  ;; common
  :use-module (nbs fp)

  :export (hex/colour2int
	   hex/colour2dec))


;;;
;;; Non API
;;;

(define (wifs col-str)
  (with-input-from-string (format #f "#x~A" col-str) read))

(define (cei int)
  (fp/round (exact->inexact (/ int 255)) 2))


;;;
;;; API
;;;

(define (hex/colour2int hex)
  (let* ((hex-str   (if (string? hex) hex (symbol->string hex)))
	 (str-red   (substring hex-str 0 2))
	 (str-green (substring hex-str 2 4))
	 (str-blue  (substring hex-str 4)))
    (values (wifs str-red)
	    (wifs str-green)
	    (wifs str-blue))))

(define (hex/colour2dec hex)
  (receive (red green blue)
      (hex/colour2int hex)
    (values (cei red)
	    (cei green)
	    (cei blue))))


#!

(use-modules (nbs hex))
(reload-module (resolve-module '(nbs hex)))


(hex/colour2int '839fa0)
(hex/colour2dec '839fa0)

!#

