;; -*- mode: scheme; coding: utf-8 -*-

;;;; Copyright (C) 2011, 2012
;;;; Free Software Foundation, Inc.
;;;;
;;;; This library is free software; you can redistribute it and/or
;;;; modify it under the terms of the GNU General Public License as
;;;; published by the Free Software Foundation; either version 3 of
;;;; the License, or (at your option) any later version.
;;;; 
;;;; This library is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;;; General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with this library; if not, write to the Free Software
;;;; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
;;;; 02110-1301 USA
;;;;

;;; Commentary:

;;; Code:

(define-module (system passwd)
  ;; guile
  ;; :use-module (ice-9 rdelim)
  ;; :use-module (ice-9 popen)

  :export (sys/get
	   sys/get-passwd))


(define sys/get #f)


(eval-when (compile load eval)
  (let* ((id (geteuid))
	 (urec (getpwuid id))
	 (gid (passwd:gid urec))
	 (grec (getgrgid gid)))
    (set! sys/get
	  (lambda (what)
	    (case what
	      ((urec) urec)
	      ((uid) (passwd:uid urec))
	      ((uname) (passwd:name urec))
	      ((udir) (passwd:dir urec))
	      ((gid) gid)
	      ((grec) grec)
	      ((gname) (group:name grec)))))))


(define (sys/get-passwd . uname)
  (if (null? uname)
      (getpwuid (geteuid))
      (getpw (car uname))))


#!

(use-modules (system passwd))
(reload-module (resolve-module '(system passwd)))

(define (get-/os-version)
  (vector-ref (uname) 2))

(sys/get 'urec)
(sys/get 'uid)
(sys/get 'uname)
(sys/get 'udir)
(sys/get 'gid)
(sys/get 'grec)
(sys/get 'gname)

!#
